export declare class Api {
    constructor();
    define<T, K>(func: (...any: any[]) => T): ApiChain<T, K>;
    static Singleton<K>(func: () => K): ApiChain<K, {}>;
    static Replace<Y, Z>(builder: ApiChain<Y, Z>, func: () => Y): () => void;
    static Mock<X, Y>(builder: ApiChain<X, Y>, func: () => Partial<Y>): () => void;
    static Merge<left, lr, lf = (...any: any[]) => any>(api1: ApiChain<left, lf>, ctor?: lf): {
        With: <right, rr, rf>(api2: ApiChain<right, rf>, ctor2?: rf | undefined) => ApiChain<left & right, {}>;
    };
}
export declare class ApiChain<Base, Ctor = (...any: any[]) => any> {
    protected level: () => Base;
    private ctor;
    constructor(level: () => Base, ctor: Ctor);
    use<K>(func: (base: Base) => K): ApiChain<K, Ctor>;
    readonly factory: {
        Create: (...any: any[]) => Base;
    };
    static Mock<X, Y>(builder: ApiChain<X, Y>, func: () => Partial<Y>): () => void;
}
